<section class="partial">
    <section>
        <h2>&#x1F3C1; Production &#x1F3C1;</h2>
    </section>

    <section>
        <h2>
            <img src="../img/pencil.svg" class="icon pencil" />
            Logging "basique"
            <img src="../img/pencil.svg" class="icon pencil" />
        </h2>
        <ul>
            <li class="fragment">Loguer tout !!!</li>
            <li class="fragment">Utiliser tous les niveaux</li>
            <li class="fragment">Identifiant unique de requête en header (<img src="../img/restify.png" class="icon restify" />)</li>
            <li class="fragment">Requête in/out (paramètres, body...)</li>
            <li class="fragment">Latence ou temps hors application</li>
        </ul>
        <aside class="notes">
            Niveaux en accord avec l'équipe pour error, warn, info...<br>
            Restify de base avec X-Request-Id<br>
            Bunyan avec X-Response-Time
        </aside>
    </section>

    <section>
        <h2>
            <img src="../img/pencil.svg" class="icon pencil" />
            Logging "brutasse"
            <img src="../img/pencil.svg" class="icon pencil" />
        </h2>
        <ul>
            <li class="fragment">Garder en mémoire tous les logs (debug, info...) puis flush sur erreur (<img src="../img/netflix.png" class="icon netflix" />)</li>
            <li class="fragment">"Garder" les logs (rewriter en winston)</li>
            <li class="fragment">Ecriture complète sur erreur (middleware finale d'erreur en loopback)</li>
            <li class="fragment">Proxy, decorateur, surcharge...</li>
        </ul>
    </section>

    <section>
        <h2>&#x1F4E1; Profiler V8 &#x1F4E1;</h2>
        <ul>
            <li class="fragment">Intégré à V8</li>
            <li class="fragment">Temps passé dans chaque couche (js, c++...)</li>
            <li class="fragment">Détail par couche</li>
            <li class="fragment">Avec : <code>node --prof app.js</code></li>
            <li class="fragment">Génère : <code>isolate-0xn...n-v8.log</code></li>
            <li class="fragment">Puis : <code>node --prof-process isolate-0xn...n-v8.log > processed.txt</code></li>
        </ul>
    </section>

    <section>
        <pre><code>
[Summary]:
   ticks  total  nonlib   name
     79    0.2%    0.2%  JavaScript
  36703   97.2%   99.2%  C++
      7    0.0%    0.0%  GC
    767    2.0%          Shared libraries
    215    0.6%          Unaccounted
        </code></pre>
        <pre><code>
[C++]:
   ticks  total  nonlib   name
  19557   51.8%   52.9%  node::crypto::PBKDF2(v8::FunctionCallbackInf...
   4510   11.9%   12.2%  _sha1_block_data_order
   3165    8.4%    8.6%  _malloc_zone_malloc
        </code></pre>
    </section>

    <section>
        <pre><code>
ticks  parent  name
19557   51.8%  node::crypto::PBKDF2(v8::FunctionCallbackInfo&lt;v8::Valu...
19557  100.0%    v8::internal::Builtins::~Builtins()
19557  100.0%      LazyCompile: ~pbkdf2 crypto.js:557:16

 4510   11.9%  _sha1_block_data_order
 4510  100.0%    LazyCompile: *pbkdf2 crypto.js:557:16
 4510  100.0%      LazyCompile: *exports.pbkdf2Sync crypto.js:552:30

 3165    8.4%  _malloc_zone_malloc
 3161   99.9%    LazyCompile: *pbkdf2 crypto.js:557:16
 3161  100.0%      LazyCompile: *exports.pbkdf2Sync crypto.js:552:30
        </code></pre>
        <aside class="notes">
            Attention à bien regarder les appels.<br>
            Ici quasi 100% dans crypto.<br>
            Bien pour le dev mais une fois l'appli en prod, les flags c'est trop tard...
        </aside>
    </section>

    <section>
        <h2 class="small">&#x1F4E1; Profiler via Javascript &#x1F4E1;</h2>
        <ul>
            <li class="fragment">Module v8-profiler <img src="../img/bulb.png" class="icon bulb" /> (ou node-profiler)</li>
            <li class="fragment">Méthodes <code>startProfiling</code> et <code>stopProfiling</code></li>
            <li class="fragment">Export / écriture du résultat</li>
            <li class="fragment">Analyse dans les Dev Tools / Profiles / CPU</li>
        </ul>
        <aside class="notes">
            Accès au profiler V8 mais avec un module programmatique !<br>
            Node-inspector et l'autre par Ben Noordhuis
        </aside>
    </section>

    <section>
        <img src="../img/cpu-profile-tree.png" alt="CPU Profile tree" />
    </section>

    <section>
        <img src="../img/cpu-profile-timeline.png" alt="CPU Profile timeline" />
    </section>

    <section>
        <h2>&#x1F4DD; Heap Dump &#x1F4DD;</h2>
        <ul>
            <li class="fragment">2 générations pour 1,5Go de heap et si les GCs ne libèrent plus... <code>Out Of Memory Error</code> !</li>
            <li class="fragment">Module v8-profiler (ou node-heampdump)</li>
            <li class="fragment">Méthode <code>takeSnapshot</code></li>
            <li class="fragment">Export / écriture du résultat</li>
            <li class="fragment">Analyse dans les Dev Tools / Profiles / Heap Snapshots</li>
        </ul>
        <aside class="notes">
            Node-inspector et l'autre par Ben Noordhuis.
        </aside>
    </section>

    <section>
        <img src="../img/heapdump.png" alt="Heapdump" />
    </section>

    <section>
        <h2>&#x1F525; FlameGraph &#x1F525;</h2>
        <ul>
            <li class="fragment">Visualisation complète de l'application</li>
            <li class="fragment">CPU / Off-CPU / Mémoire / ...</li>
            <li class="fragment">Linux <code>perf</code>, OSX <code>dtrace</code> et Windows <code>Xperf</code></li>
            <li class="fragment">
                Module 0x : génération à la demande en local ou en production
                <img src="../img/bulb.png" class="icon bulb" />
            </li>
        </ul>
    </section>

    <section>
        <img src="../img/flame-graph.svg" alt="FlameGraph" />
    </section>

    <section>
        <h2>&#x1F529; Automatisation &#x1F529;</h2>
        <ul>
            <li class="fragment">Profiling à la demande</li>
            <li class="fragment">API ou signal <code>SIGUSR2</code></li>
            <li class="fragment">Heapdump puis CPU puis Heapdump</li>
            <li class="fragment">Faire un <code>compare</code> des 2 headpdumps</li>
            <li class="fragment">Toutes les 30 minutes (<img src="../img/netflix.png" class="icon netflix" />)</li>
            <li class="fragment">Poser des alertes</li>
        </ul>
    </section>
</section>
